(load "packages")
(in-package :hello-lisp.practical-common-lisp.binary-parser)
(load "common")


;; reading and writing binary files with a specified format


;; defining reading and writing functions manually (examples of code that will
;; be generated by macros later)

;; numbers (big-endian)

(defun read-u2 (in)
  "Reads and returns an unsigned 16-bit integer from the stream IN."
  (let ((u2 0))
    (setf (ldb (byte 8 8) u2) (read-byte in))
    (setf (ldb (byte 8 0) u2) (read-byte in))
    u2))

(defun write-u2 (out value)
  "Writes an unsigned 16-bit integer VALUE to the stream OUT."
  (write-byte (ldb (byte 8 8) value) out)
  (write-byte (ldb (byte 8 0) value) out))

(comment

 (with-open-file (out "integer.txt"
                      :direction :output
                      :if-exists :supersede
                      :element-type '(unsigned-byte 8))
   (write-u2 out 65532))

 (with-open-file (in "integer.txt" :element-type '(unsigned-byte 8))
   (read-u2 in))

)

;; strings

(defconstant +null+ (code-char 0))

(defun read-null-terminated-ascii (in)
  "Reads and returns a null-terminated string from the stream IN."
  (with-output-to-string (s)
    (loop for char = (code-char (read-byte in))
          until (char= char +null+)
          do (write-char char s))))

(defun write-null-terminated-ascii (string out)
  "Writes the null-terminated string STRING to the stream OUT."
  (loop for char across string
        do (write-byte (char-code char) out))
  (write-byte (char-code +null+) out))

(comment

 (with-open-file (out "string.txt"
                      :direction :output
                      :if-exists :supersede
                      :element-type '(unsigned-byte 8))
   (write-null-terminated-ascii "this is also a null-terminated string!" out))

 (with-open-file (in "string.txt" :element-type '(unsigned-byte 8))
   (read-null-terminated-ascii in))

)

;; composite structures

;; example: ID3 tag

(defclass id3-tag ()
  ((identifier :initarg :identifier :accessor identifier)
   (major-version :initarg :major-version :accessor major-version)
   (revision :initarg :revision :accessor revision)
   (flags :initarg :flags :accessor flags)
   (size :initarg :size :accessor size)
   (frames :initarg :frames :accessor frames)))

(defun read-id3-tag (in)
  "Reads and returns an ID3 tag data structure from the stream IN."
  (let ((tag (make-instance 'id3-tag)))
    (with-slots (identifier major-version revision flags size frames) tag
      (setf identifier (read-ascii-string in :length 3))
      (setf major-version (read-u1 in))
      (setf revision (read-u1 in))
      (setf flags (read-u1 in))
      (setf size (read-id3-encoded-size in))
      (setf frames (read-id3-frames in :tag-size size)))))

(defun write-id3-tag (out tag)
  "Writes the ID3 tag TAG to the stream OUT."
  (with-slots (identifier major-version revision flags size frames) tag)
  (write-ascii-string out identifier)
  (write-u1 out major-version)
  (write-u1 out revision)
  (write-u1 out flags)
  (write-id3-encoded-size out size)
  (write-id3-frames out frames))

;; the definitions are quite wordy and also expected to be quite similar for
;; different binary formats (differing only in types and names of slots); a
;; macro could simplify the definition process


;; designing the macros for defining binary formats

;; we already have examples of the code to be generated, now we need examples
;; of how the macro call should look like (see the chapter dedicated to
;; writing macros for the description of the macro writing process)

(comment

 ;; macroexpand it after the macro is defined (e.g. `sly-macroexpand-1')

 (define-binary-format id3-tag
     (file-type-identifier (ascii-string :length 3))
   (major-version u1)
   (revision u1)
   (flags u1)
   (size id3-tag-size)
   (frames (id3-frames :tag-size size)))

 ;; example of deserializer generic method definition that will be generated
 ;; by the `define-binary-format' macro

 (defmethod read-value ((type (eql 'id3-tag)) in &key)
   (let ((object (make-instance 'id3-tag)))
     (with-slots (identifier major-version revision flags size frames) object
       (setf identifier (read-value 'ascii-string in :length 3))
       (setf major-version (read-value 'u1 in))
       (setf revision (read-value 'u1 in))
       (setf flags (read-value 'u1 in))
       (setf size (read-value 'id3-encoded-size in))
       (setf frames (read-value 'id3-frames in :tag-size size)))))

 (slot->read-value '(major-version u1) 'stream)
 (slot->write-value '(major-version u1) 'stream)

)


(defun as-keyword (sym)
  "Returns SYM as a keyword. Interns SYM in the keyword package."
  (intern (string sym) :keyword))

(defun slot->defclass-slot (spec)
  "Returns a class slot form based on the slot specifier SPEC."
  (let ((name (first spec)))
    `(,name :initarg ,(as-keyword name) :accessor ,name)))

(defun ensure-list (value)
  "Returns VALUE in a list, if it is not a list already."
  (if (listp value) value (list value)))

(defun slot->read-value (spec stream)
  "Returns a slot setting expression for the slot specified in SPEC, with the
value read from STREAM."
  (destructuring-bind
      (name (type &rest args)) (list (first spec) (ensure-list (second spec)))
    `(setf ,name (read-value ',type ,stream ,@args))))

(defun slot->write-value (spec stream)
  "Returns an expression for writing a value from the slot specified in SPEC to
the STREAM."
  (destructuring-bind
      (name (type &rest args)) (list (first spec) (ensure-list (second spec)))
    `(write-value ',type ,stream ,name ,@args)))


(defgeneric read-value (type stream &key)
  (:documentation "Reads and returns a value of the TYPE from the STREAM."))

(defgeneric write-value (type stream value &key)
  (:documentation "Writes the VALUE of the TYPE to the STREAM."))

(defmacro define-binary-format (name &rest slots)
  "Defines a binary format class and serialization/deserialization functions for
it."
  (with-gensyms (typevar objectvar streamvar)
    `(progn
       (defclass ,name ()
         ,(mapcar #'slot->defclass-slot slots))
       (defmethod read-value ((,typevar (eql ',name)) ,streamvar &key)
         (let ((,objectvar (make-instance ',name)))
           (with-slots ,(mapcar #'first slots) ,objectvar
             ,@(mapcar #'(lambda (x) (slot->read-value x streamvar)) slots))
           ,objectvar))
       (defmethod write-value ((,typevar (eql ',name))
                               ,streamvar ,objectvar &key)
         (with-slots ,(mapcar #'first slots) ,objectvar
           ,@(mapcar #'(lambda (x) (slot->write-value x streamvar)) slots))))))
